diff --git a/gnu/packages/golang.scm b/gnu/packages/golang.scm
index 3a632b0705..074e8e6bdf 100644
--- a/gnu/packages/golang.scm
+++ b/gnu/packages/golang.scm
@@ -74,6 +74,140 @@
   #:use-module (ice-9 match)
   #:use-module (srfi srfi-1))
 
+(define-public go-github-com-go-gl-gl
+  (let ((commit "69f74958bac0960e82e8ac5977ff073af29381ba")
+        (revision "87"))
+    (package
+      (name "go-github-com-go-gl-gl")
+      (version (git-version "0.0.0" revision commit))
+      (source
+       (origin
+         (method git-fetch)
+         (uri
+          (git-reference
+           (url "https://github.com/go-gl/gl")
+           (commit commit)))
+         (file-name (git-file-name name version))
+         (sha256
+          (base32 "15bqz4dax3b5ha9qcc855aczsa89qa65p578dnjrbww53q31s5w0"))))
+      (build-system go-build-system)
+      (arguments
+       `(#:unpack-path "github.com/go-gl/gl"
+         #:phases
+         (modify-phases %standard-phases
+           (replace 'build
+             (lambda* (#:key source system outputs search-paths build-flags unpack-path inputs #:allow-other-keys)
+               (for-each
+                (lambda (directory)
+                  ((assoc-ref %standard-phases 'build)
+                   #:source source
+                   #:system system
+                   #:outputs outputs
+                   #:search-paths search-paths
+                   #:build-flags build-flags
+                   #:unpack-path unpack-path
+                   #:inputs inputs
+                   #:import-path directory))
+                (list
+                 "github.com/go-gl/gl/all-core/gl"
+                 "github.com/go-gl/gl/v2.1/gl"
+                 "github.com/go-gl/gl/v3.1/gles2"
+                 "github.com/go-gl/gl/v3.2-compatibility/gl"
+                 "github.com/go-gl/gl/v3.2-core/gl"
+                 "github.com/go-gl/gl/v3.3-compatibility/gl"
+                 "github.com/go-gl/gl/v3.3-core/gl"
+                 "github.com/go-gl/gl/v4.1-compatibility/gl"
+                 "github.com/go-gl/gl/v4.1-core/gl"
+                 "github.com/go-gl/gl/v4.2-compatibility/gl"
+                 "github.com/go-gl/gl/v4.2-core/gl"
+                 "github.com/go-gl/gl/v4.3-compatibility/gl"
+                 "github.com/go-gl/gl/v4.3-core/gl"
+                 "github.com/go-gl/gl/v4.4-compatibility/gl"
+                 "github.com/go-gl/gl/v4.4-core/gl"
+                 "github.com/go-gl/gl/v4.5-compatibility/gl"
+                 "github.com/go-gl/gl/v4.5-core/gl"
+                 "github.com/go-gl/gl/v4.6-compatibility/gl"
+                 "github.com/go-gl/gl/v4.6-core/gl"))
+               #t))
+           (replace 'check
+             (lambda* (#:key source system outputs search-paths tests? unpack-path inputs #:allow-other-keys)
+               (for-each
+                (lambda (directory)
+                  ((assoc-ref %standard-phases 'check)
+                   #:source source
+                   #:system system
+                   #:outputs outputs
+                   #:search-paths search-paths
+                   #:tests? tests?
+                   #:unpack-path unpack-path
+                   #:inputs inputs
+                   #:import-path directory))
+                (list
+                 "github.com/go-gl/gl/all-core/gl"
+                 "github.com/go-gl/gl/v2.1/gl"
+                 "github.com/go-gl/gl/v3.1/gles2"
+                 "github.com/go-gl/gl/v3.2-compatibility/gl"
+                 "github.com/go-gl/gl/v3.2-core/gl"
+                 "github.com/go-gl/gl/v3.3-compatibility/gl"
+                 "github.com/go-gl/gl/v3.3-core/gl"
+                 "github.com/go-gl/gl/v4.1-compatibility/gl"
+                 "github.com/go-gl/gl/v4.1-core/gl"
+                 "github.com/go-gl/gl/v4.2-compatibility/gl"
+                 "github.com/go-gl/gl/v4.2-core/gl"
+                 "github.com/go-gl/gl/v4.3-compatibility/gl"
+                 "github.com/go-gl/gl/v4.3-core/gl"
+                 "github.com/go-gl/gl/v4.4-compatibility/gl"
+                 "github.com/go-gl/gl/v4.4-core/gl"
+                 "github.com/go-gl/gl/v4.5-compatibility/gl"
+                 "github.com/go-gl/gl/v4.5-core/gl"
+                 "github.com/go-gl/gl/v4.6-compatibility/gl"
+                 "github.com/go-gl/gl/v4.6-core/gl"))
+               #t))
+           (replace 'install
+             (lambda* (#:key source system outputs search-paths install-source? unpack-path inputs #:allow-other-keys)
+               (for-each
+                (lambda (directory)
+                  ((assoc-ref %standard-phases 'install)
+                   #:source source
+                   #:system system
+                   #:outputs outputs
+                   #:search-paths search-paths
+                   #:install-source? install-source?
+                   #:unpack-path unpack-path
+                   #:inputs inputs
+                   #:import-path directory))
+                (list
+                 "github.com/go-gl/gl/all-core/gl"
+                 "github.com/go-gl/gl/v2.1/gl"
+                 "github.com/go-gl/gl/v3.1/gles2"
+                 "github.com/go-gl/gl/v3.2-compatibility/gl"
+                 "github.com/go-gl/gl/v3.2-core/gl"
+                 "github.com/go-gl/gl/v3.3-compatibility/gl"
+                 "github.com/go-gl/gl/v3.3-core/gl"
+                 "github.com/go-gl/gl/v4.1-compatibility/gl"
+                 "github.com/go-gl/gl/v4.1-core/gl"
+                 "github.com/go-gl/gl/v4.2-compatibility/gl"
+                 "github.com/go-gl/gl/v4.2-core/gl"
+                 "github.com/go-gl/gl/v4.3-compatibility/gl"
+                 "github.com/go-gl/gl/v4.3-core/gl"
+                 "github.com/go-gl/gl/v4.4-compatibility/gl"
+                 "github.com/go-gl/gl/v4.4-core/gl"
+                 "github.com/go-gl/gl/v4.5-compatibility/gl"
+                 "github.com/go-gl/gl/v4.5-core/gl"
+                 "github.com/go-gl/gl/v4.6-compatibility/gl"
+                 "github.com/go-gl/gl/v4.6-core/gl"))
+               #t)))))
+      (native-inputs
+       `(("pkg-config" ,pkg-config)))
+      (inputs
+       `(("mesa" ,mesa)))
+      (propagated-inputs
+       `(("go-github-com-go-gl-glow" ,go-github-com-go-gl-glow)))
+      (home-page "https://github.com/go-gl/gl")
+      (synopsis "Go bindings for OpenGL")
+      (description "Go-GL holds Go bindings to various OpenGL versions.")
+      (license license:expat))))
+
 (define-public go-github-com-go-gl-glow
   (let ((commit "640349a6105e64eb9e5085d2afee1ab2ec67d2dc")
         (revision "300"))