diff --git a/gnu/packages/golang.scm b/gnu/packages/golang.scm
index d51c023808cf..b99659966dda 100644
--- a/gnu/packages/golang.scm
+++ b/gnu/packages/golang.scm
@@ -2755,7 +2755,7 @@ (define-public go-github-com-gizak-termui
      '(#:unpack-path "github.com/gizak/termui"
        #:import-path "github.com/gizak/termui/v3"))
     (propagated-inputs
-     (list go-github.com-mattn-go-runewidth
+     (list go-github-com-mattn-go-runewidth
            go-github-com-mitchellh-go-wordwrap go-github.com-nsf-termbox-go))
     (home-page "https://github.com/gizak/termui")
     (synopsis "Terminal dashboard widget Go library")
@@ -7105,7 +7105,7 @@ (define-public go-github-com-gdamore-tcell
       (arguments
        `(#:import-path "github.com/gdamore/tcell"))
       (inputs
-       (list go-github.com-mattn-go-runewidth
+       (list go-github-com-mattn-go-runewidth
              go-github-com-lucasb-eyer-go-colorful
              go-golang-org-x-text
              go-github-com-gdamore-encoding))
@@ -9128,7 +9128,7 @@ (define-public go-github-com-muesli-reflow-wordwrap
      `(#:import-path "github.com/muesli/reflow/wordwrap"
        #:unpack-path "github.com/muesli/reflow"))
     (native-inputs
-     (list go-github.com-mattn-go-runewidth))
+     (list go-github-com-mattn-go-runewidth))
     (home-page "https://github.com/muesli/reflow/")
     (synopsis "Collection of methods helping to transform blocks of text")
     (description "This package provides a collection of ANSI-aware methods and
@@ -9187,7 +9187,7 @@ (define-public go-github-com-muesli-termenv
      (list go-github-com-google-goterm
            go-github-com-lucasb-eyer-go-colorful
            go-github-com-mattn-go-isatty
-           go-github.com-mattn-go-runewidth))
+           go-github-com-mattn-go-runewidth))
     (home-page "https://github.com/muesli/termenv/")
     (synopsis "Advanced styling options on the terminal")
     (description "termenv lets you safely use advanced styling options on the
@@ -9241,7 +9241,7 @@ (define-public go-github-com-olekukonko-tablewriter
     (arguments
      `(#:import-path "github.com/olekukonko/tablewriter"))
     (propagated-inputs
-     (list go-github.com-mattn-go-runewidth))
+     (list go-github-com-mattn-go-runewidth))
     (home-page "https://github.com/olekukonko/tablewriter/")
     (synopsis "Generate ASCII table")
     (description "This package generates ASCII tables.  Features:
@@ -9338,7 +9338,7 @@ (define-public go-github-com-charmbracelet-glamour
            go-github-com-muesli-reflow-wordwrap
            go-github-com-muesli-reflow-indent
            go-github-com-muesli-reflow-padding
-           go-github.com-mattn-go-runewidth
+           go-github-com-mattn-go-runewidth
            go-github-com-muesli-termenv
            go-github-com-google-goterm
            go-github-com-lucasb-eyer-go-colorful
@@ -11521,7 +11521,7 @@ (define-public go-github-com-rivo-uniseg
 (define-public go-github-com-mattn-go-runewidth
   (package
     (name "go-github-com-mattn-go-runewidth")
-    (version "0.0.13")
+    (version "0.0.14")
     (source
      (origin
        (method git-fetch)
@@ -11530,7 +11530,7 @@ (define-public go-github-com-mattn-go-runewidth
              (commit (string-append "v" version))))
        (file-name (git-file-name name version))
        (sha256
-        (base32 "1yir0f3wc5z5hnkwhvx5qb6nmpfb05zp2gvfjvna63s8kmla1rrn"))))
+        (base32 "1iaqw5pd7f4f2xz37540kp0828p2820g4vxx3hz089hwl331sx1v"))))
     (build-system go-build-system)
     (arguments '(#:import-path "github.com/mattn/go-runewidth"))
     (propagated-inputs
@@ -11563,7 +11563,7 @@ (define-public go-github-com-charmbracelet-bubbletea
     (propagated-inputs
      `(("github.com/mattn/go-isatty" ,go-github-com-mattn-go-isatty)
        ("github.com/muesli/termenv" ,go-github-com-muesli-termenv)
-       ("github.com/mattn/go-runewidth" ,go-github.com-mattn-go-runewidth)
+       ("github.com/mattn/go-runewidth" ,go-github-com-mattn-go-runewidth)
        ("go-github-com-muesli-reflow-indent" ,go-github-com-muesli-reflow-indent)
        ("go-github-com-muesli-reflow-ansi" ,go-github-com-muesli-reflow-ansi)
        ("go-github-com-lucasb-eyer-go-colorful" ,go-github-com-lucasb-eyer-go-colorful)